summaryrefslogtreecommitdiffstats
path: root/scripts/gen_ll_addressable_symbols.sh
diff options
context:
space:
mode:
authorMarek Behún <marek.behun@nic.cz>2021-05-20 13:24:03 +0200
committerTom Rini <trini@konsulko.com>2021-05-24 14:21:30 -0400
commitc1094987d1dc4701646c5f3aa254e7a92a02d305 (patch)
tree5d2bbcee39b8adff66ac767d8bde1bcb6283dfe7 /scripts/gen_ll_addressable_symbols.sh
parent958f2e57eff72b5156f7b08b9c1415fb7e12833d (diff)
downloadu-boot-c1094987d1dc4701646c5f3aa254e7a92a02d305.tar.gz
u-boot-c1094987d1dc4701646c5f3aa254e7a92a02d305.tar.xz
u-boot-c1094987d1dc4701646c5f3aa254e7a92a02d305.zip
build: support building with Link Time Optimizations
Add plumbing for building U-Boot with Link Time Optimizations. When building with LTO, $(PLATFORM_LIBS) has to be in --whole-archive / --no-whole-archive group, otherwise some functions declared in assembly may not be resolved and linking may fail. Note: clang may throw away linker list symbols it thinks are unused when compiling with LTO. To force these symbols to be included, we refer to them via the __ADDRESSABLE macro in a C file generated from compiled built-in.o files before linking. Signed-off-by: Marek Behún <marek.behun@nic.cz> Reviewed-by: Simon Glass <sjg@chromium.org>
Diffstat (limited to 'scripts/gen_ll_addressable_symbols.sh')
-rwxr-xr-xscripts/gen_ll_addressable_symbols.sh12
1 files changed, 12 insertions, 0 deletions
diff --git a/scripts/gen_ll_addressable_symbols.sh b/scripts/gen_ll_addressable_symbols.sh
new file mode 100755
index 0000000000..3978a39d97
--- /dev/null
+++ b/scripts/gen_ll_addressable_symbols.sh
@@ -0,0 +1,12 @@
+#!/bin/bash
+# SPDX-License-Identifier: GPL-2.0+
+# Copyright (C) 2020 Marek Behún <marek.behun@nic.cz>
+
+# Generate __ADDRESSABLE(symbol) for every linker list entry symbol, so that LTO
+# does not optimize these symbols away
+
+set -e
+
+echo '#include <common.h>'
+$NM "$@" 2>/dev/null | grep -oe '_u_boot_list_2_[a-zA-Z0-9_]*_2_[a-zA-Z0-9_]*' | \
+ sort -u | sed -e 's/^\(.*\)/extern char \1[];\n__ADDRESSABLE(\1);/'